;
;   Boot-n-Load
;
;   Bootable floppy.  BIOS loads one sector, executes it.  The
;   executable loads the next level of code.
;
;   To build & use (DOS Batch file):
;
;;  ;;            NASM16 -f bin -o bnl1.bin -l bnl1.lst bnl1.asm
;;  ;;            NASM16 -f bin -o bnl2.bin -l bnl2.lst bnl2.asm
;;  ;;            copy  /b bnl1.bin+bnl2.bin bnl.bin
;;  ;;            rawrite2 -f bnl.bin -d A -n
;Most from theNbomr http://www.linuxquestions.org inprovd by me
LEVEL2_SEG      equ     0x4000;0x9000
LEVEL2_OFF      equ     0x0100;0x0000

[BITS 16]
[ORG 0]

BnL_start:
;
;   We know the absolute address, but some BIOSes use different
;   SEG:OFF combos.  This makes sure we are using offsets that agree
;   with our ORG statement
;
    jmp     0x07c0:BnL_Go


BnL_HelloMsg:
    db      'BnL ver 0.1',0x0d,0x0a,0

BnL_Go:
    mov     ax, cs
    mov     es, ax
    mov     ds, ax
;
;   Set up a stack
;
    cli
    mov     sp, 0xffff
    mov     ax, LEVEL2_SEG
    mov     ss, ax
    sti

    mov     si, BnL_HelloMsg    ; Print msg
BnL_SayHello:
    lodsb                       ; AL=memory contents at DS:SI

    cmp     al, 0               ; If AL=0 then done talking
    je      BnL_ResetDisk       ; go on to next step

    mov     ah, 0x0E            ; Print AL
    mov     bx, 7               ; text attribute/colour
    int     10h                 ; BIOS Print Char

    jmp     BnL_SayHello        ; Print next character

;
;   Load the next piece of code from sector 2, 3...
;

BnL_ResetDisk:

    mov     ax, 0
    int     0x13            ;
    jc      BnL_ResetDisk

BnL_Reload:
    mov     ax, LEVEL2_SEG
    mov     es, ax          ; SEgment address for destination
    mov     ah, 02          ; BIOS Int 13h func: Read disk
    mov     al, 17           ; sector count
    mov     bx, LEVEL2_OFF  ; Address OFFSET for destination (ES:BX --> dest)
    mov     ch, 0           ; Disk cylinder
    mov     cl, 2           ; Sector (numbered from 1)
    mov     dh, 0           ; Head
    mov     dl, 0           ; Drive
    int     0x13
    mov     ax, LEVEL2_SEG
    add     ax, 544;76
    mov     es, ax          ; SEgment address for destination
    mov     ah, 02          ; BIOS Int 13h func: Read disk
    mov     al, 17           ; sector count
    mov     bx, LEVEL2_OFF  ; Address OFFSET for destination (ES:BX --> dest)
    mov     ch, 0           ; Disk cylinder
    mov     cl, 1           ; Sector (numbered from 1)
    mov     dh, 1           ; Head
    mov     dl, 0           ; Drive
    int     0x13
    jc      BnL_Reload



    jmp     LEVEL2_SEG:LEVEL2_OFF

TIMES 510-($-$$) db 0x90
    dw      0AA55h

;
;=========================================================================
;   The following code is loaded from disk sector(s) following
;   the sector 1 code loaded and invoked by the BIOS.
;   We jump to this code from the bootstrap loader above.
;
;
;    mov     ax, cs
;    mov     es, ax
;    mov     ds, ax
;
;    mov     si, BnL2_HelloMsg
;BnL2_SayHello:
;    lodsb                       ; AL=memory contents at DS:SI
;
;    cmp     al, 0               ; If AL=0 then done talking
;    je      BnL2_Go             ; go on to next step
;
;    mov     ah, 0x0E            ; Print AL
;    mov     bx, 7               ; text attribute/colour
;    int     10h                 ; BIOS Print Char
;
;    jmp     BnL2_SayHello       ; Print next character
;
;
;BnL2_Go:
;    jmp     $
;
;BnL2_HelloMsg:
;    db      'Now using level2 code', 0
;
;times 1022-($-$$) db 0xff
;dw 0AA55h
